﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinDataSource;
using Infragistics.Win;

namespace SampleApp
{
    public partial class Form1 : Form
    {
        DataSet ds = new DataSet();
        UltraDataSource ultraDataSource1;
        private RichTextBox descriptionEditor = new RichTextBox();

        public Form1()
        {
            InitializeComponent();
            ultraDataSource1 = new UltraDataSource();
            ultraDataSource1.Band.Columns.Add("Number");
            ultraDataSource1.Band.Columns.Add("FullName");
            ultraDataSource1.Band.ChildBands.Add("Message").Columns.Add("Data", typeof (string));
            ds.ReadXml("Person.xml");
            // Reset UltraDataSource
            ultraDataSource1.Rows.Clear();
            // Add the rows to the grid
            UltraDataRowsCollection childRows = null;
     
            for (int rowNum = 0; rowNum < ds.Tables[0].Rows.Count; rowNum++)
            {
                Infragistics.Win.UltraWinDataSource.UltraDataRow MainRow = ultraDataSource1.Rows.Add();
                
                MainRow[0] = ds.Tables[0].Rows[rowNum]["ID"].ToString();
                MainRow[1] = ds.Tables[0].Rows[rowNum]["Name"].ToString();

                if (ds.Tables[0].Rows[rowNum]["Message"].ToString() != string.Empty)
                {
                    UltraDataBand childBand = this.ultraDataSource1.Band.ChildBands["Message"];                    
                    // Initialize the child rows of the row.                        
                    childRows = MainRow.GetChildRows(childBand);                    
                    childRows.SetCount(1);
                    childRows[0][0] =  ds.Tables[0].Rows[rowNum]["Message"].ToString().Replace ("\r\n", "<br/>");                    
                }                
            }
            ultraGrid1.DataSource = ultraDataSource1;            
            
            ultraGrid1.Rows.ExpandAll(true);
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.AllowColSizing = AllowColSizing.Free;
            e.Layout.Override.RowSizing = RowSizing.AutoFree;
            
            UltraGridBand bandComments = e.Layout.Bands["Message"];
            
            //ultraGrid1.DisplayLayout.Override.DefaultColWidth = 250; // overall column widtj
            //ultraGrid1.DisplayLayout.Bands[0].Columns[0].CellMultiLine = DefaultableBoolean.True;
            //ultraGrid1.DisplayLayout.Bands[0].Columns[0].VertScrollBar = true;
            //ultraGrid1.DisplayLayout.Override.AllowGroupBy =  DefaultableBoolean.True;

            // because of this we can see the bold text but not see the formated text as we see in xml.
            bandComments.Columns[0].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.FormattedTextEditor; 
            
            #region Approach #1
           // //Text Properties
           // descriptionEditor.MaxLength = 4000;
           // descriptionEditor.Multiline = true;

           // ////Container
           // Infragistics.Win.UltraWinEditors.UltraControlContainerEditor descriptionContainerEditor = new Infragistics.Win.UltraWinEditors.UltraControlContainerEditor();
           // descriptionContainerEditor.EditingControl = descriptionEditor;
           //// descriptionContainerEditor.EditingControlPropertyName = "Text";
           // ////Assign contain editore to band.
           // bandComments.Columns[0].EditorComponent = descriptionContainerEditor;
            
            #endregion

            #region Approach #2
            //bandComments.Override.DefaultColWidth = 320;

            //e.Layout.Override.DefaultRowHeight = 30;
            //bandComments.Columns[0].VertScrollBar = true;
            //bandComments.Columns[0].CellMultiLine = DefaultableBoolean.True;
            //bandComments.Columns[0].AutoSizeMode = ColumnAutoSizeMode.AllRowsInBand;
            //bandComments.Columns[0].Width = 500;
            //bandComments.Columns[0].PerformAutoResize(PerformAutoSizeType.None, AutoResizeColumnWidthOptions.All);
            //bandComments.Override.DefaultColWidth = 0;
            //bandComments.Override.DefaultRowHeight = 200;
            #endregion
            
        }
    }
}
